
#include "stdafx.h"
#include "video.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVideoApp NEAR theApp;

const GUID CDECL BASED_CODE _tlid = { 0x96872fa0, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;

BOOL CVideoApp::InitInstance()
{
	return COleControlModule::InitInstance();
}

int CVideoApp::ExitInstance()
{
	return COleControlModule::ExitInstance();
}

STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid)) return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(TRUE)) return ResultFromScode(SELFREG_E_CLASS);
	return NOERROR;
}

STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);
	if (!AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor)) return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(FALSE)) return ResultFromScode(SELFREG_E_CLASS);
	return NOERROR;
}

void DrawOcxBitmap(COleControl *me, CDC* pdc, const CRect& rcBounds, int idbmp)
{
   // Bild anzeigen
   RECT r;
   if (me->m_hWnd) me->GetWindowRect(&r); else r=rcBounds;
   HDC hdcMem=CreateCompatibleDC(pdc->m_hDC); 
   HBITMAP hbmp=LoadBitmap(theApp.m_hInstance, MAKEINTRESOURCE(idbmp));
   SelectObject(hdcMem, hbmp); 
   BITMAP bm; GetObject(hbmp, sizeof(BITMAP), (LPSTR) &bm); 
   StretchBlt(pdc->m_hDC, me->m_hWnd?0:r.left, me->m_hWnd?0:r.top, r.right-r.left, r.bottom-r.top, /*rcBounds.TopLeft().x, rcBounds.TopLeft().y, rcBounds.Width(), rcBounds.Height(), */ hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
   DeleteDC(hdcMem); 
   DeleteObject(hbmp);

   // Rand
   CPen cp, *cpold;
   HANDLE hbold;
   cp.CreatePen(0, 1, (COLORREF)0L);
   cpold=pdc->SelectObject(&cp);
   hbold=SelectObject(pdc->m_hDC, GetStockObject(NULL_BRUSH));
   pdc->Rectangle(rcBounds);
   pdc->SelectObject(cpold);
   SelectObject(pdc->m_hDC, hbold);
}

